clang 10.0.0git

Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::CXXCatchStmt Class Reference

CXXCatchStmt - This represents a C++ catch block. More...

`#include "clang/AST/StmtCXX.h"`

Inheritance diagram for clang::CXXCatchStmt:
[legend]
Collaboration diagram for clang::CXXCatchStmt:
[legend]

## Public Member Functions
| CXXCatchStmt (SourceLocation catchLoc, VarDecl *exDecl, Stmt *handlerBlock)
| CXXCatchStmt (EmptyShell Empty)
SourceLocation | getBeginLoc () const LLVM_READONLY
SourceLocation | getEndLoc () const LLVM_READONLY
SourceLocation | getCatchLoc () const
VarDecl * | getExceptionDecl () const
QualType | getCaughtType () const
Stmt * | getHandlerBlock () const
child_range | children ()
const_child_range | children () const
Public Member Functions inherited from clang::Stmt
void * | operator new (size_t bytes, const ASTContext &C, unsigned alignment=8)
void * | operator new (size_t bytes, const ASTContext *C, unsigned alignment=8)
void * | operator new (size_t bytes, void *mem) noexcept
void | operator delete (void *, const ASTContext &, unsigned) noexcept
void | operator delete (void *, const ASTContext *, unsigned) noexcept
void | operator delete (void *, size_t) noexcept
void | operator delete (void *, void *) noexcept
| Stmt ()=delete
| Stmt (const Stmt &)=delete
| Stmt (Stmt &&)=delete
Stmt & | operator= (const Stmt &)=delete
Stmt & | operator= (Stmt &&)=delete
| Stmt (StmtClass SC)
StmtClass | getStmtClass () const
const char * | getStmtClassName () const
bool | isOMPStructuredBlock () const
void | setIsOMPStructuredBlock (bool IsOMPStructuredBlock)
SourceRange | getSourceRange () const LLVM_READONLY
| SourceLocation tokens are not useful in isolation - they are low level value objects created/interpreted by SourceManager. More...
SourceLocation | getBeginLoc () const LLVM_READONLY
SourceLocation | getEndLoc () const LLVM_READONLY
void | dump () const
| Dumps the specified AST fragment and all subtrees to `llvm::errs()`. More...
void | dump (SourceManager &SM) const
void | dump (raw_ostream &OS, SourceManager &SM) const
void | dump (raw_ostream &OS) const
int64_t | getID (const ASTContext &Context) const
void | dumpColor () const
| dumpColor - same as dump(), but forces color highlighting. More...
void | dumpPretty (const ASTContext &Context) const
| dumpPretty/printPretty - These two methods do a "pretty print" of the AST back to its original source language syntax. More...
void | printPretty (raw_ostream &OS, PrinterHelper *Helper, const PrintingPolicy &Policy, unsigned Indentation=0, StringRef NewlineSymbol="\, const ASTContext *Context=nullptr) const
void | printJson (raw_ostream &Out, PrinterHelper *Helper, const PrintingPolicy &Policy, bool AddQuotes) const
| Pretty-prints in JSON format. More...
void | viewAST () const
| viewAST - Visualize an AST rooted at this Stmt* using GraphViz. More...
Stmt * | IgnoreContainers (bool IgnoreCaptured=false)
| Skip no-op (attributed, compound) container stmts and skip captured stmt at the top, if IgnoreCaptured is true. More...
const Stmt * | IgnoreContainers (bool IgnoreCaptured=false) const
const Stmt * | stripLabelLikeStatements () const
| Strip off all label-like statements. More...
Stmt * | stripLabelLikeStatements ()
child_range | children ()
const_child_range | children () const
child_iterator | child_begin ()
child_iterator | child_end ()
const_child_iterator | child_begin () const
const_child_iterator | child_end () const
void | Profile (llvm::FoldingSetNodeID &ID, const ASTContext &Context, bool Canonical) const
| Produce a unique representation of the given statement. More...
void | ProcessODRHash (llvm::FoldingSetNodeID &ID, ODRHash &Hash) const
| Calculate a unique representation for a statement that is stable across compiler invocations. More...

## Static Public Member Functions
static bool | classof (const Stmt *T)
Static Public Member Functions inherited from clang::Stmt
static void | addStmtClass (const StmtClass s)
static void | EnableStatistics ()
static void | PrintStats ()

## Friends
class | ASTStmtReader

## Additional Inherited Members
Public Types inherited from clang::Stmt
enum | StmtClass { NoStmtClass = 0 }
using | child_iterator = StmtIterator
| Child Iterators: All subclasses must implement 'children' to permit easy iteration over the substatements/subexpessions of an AST node. More...
using | const_child_iterator = ConstStmtIterator
using | child_range = llvm::iterator_range< child_iterator >
using | const_child_range = llvm::iterator_range< const_child_iterator >
Protected Types inherited from clang::Stmt
enum | { NumStmtBits = 9 }
enum | { NumExprBits = NumStmtBits + 9 }
enum | { NumCallExprBits = 32 }
enum | { NumOverloadExprBits = NumExprBits + 1 }
template<typename T >
using | ConstCastIterator = CastIterator< T, const T *const, const Stmt *const >
| Const iterator for iterating over Stmt * arrays that contain only T *. More...
using | ExprIterator = CastIterator< Expr >
using | ConstExprIterator = ConstCastIterator< Expr >
Protected Member Functions inherited from clang::Stmt
void * | operator new (size_t bytes) noexcept
void | operator delete (void *data) noexcept
| Stmt (StmtClass SC, EmptyShell)
| Construct an empty statement. More...
Protected Attributes inherited from clang::Stmt
union {
StmtBitfields StmtBits
NullStmtBitfields NullStmtBits
CompoundStmtBitfields CompoundStmtBits
LabelStmtBitfields LabelStmtBits
AttributedStmtBitfields AttributedStmtBits
IfStmtBitfields IfStmtBits
SwitchStmtBitfields SwitchStmtBits
WhileStmtBitfields WhileStmtBits
DoStmtBitfields DoStmtBits
ForStmtBitfields ForStmtBits
GotoStmtBitfields GotoStmtBits
ContinueStmtBitfields ContinueStmtBits
BreakStmtBitfields BreakStmtBits
ReturnStmtBitfields ReturnStmtBits
SwitchCaseBitfields SwitchCaseBits
ExprBitfields ExprBits
ConstantExprBitfields ConstantExprBits
PredefinedExprBitfields PredefinedExprBits
DeclRefExprBitfields DeclRefExprBits
FloatingLiteralBitfields FloatingLiteralBits
StringLiteralBitfields StringLiteralBits
CharacterLiteralBitfields CharacterLiteralBits
UnaryOperatorBitfields UnaryOperatorBits
UnaryExprOrTypeTraitExprBitfields UnaryExprOrTypeTraitExprBits
ArraySubscriptExprBitfields ArraySubscriptExprBits
CallExprBitfields CallExprBits
MemberExprBitfields MemberExprBits
CastExprBitfields CastExprBits
BinaryOperatorBitfields BinaryOperatorBits
InitListExprBitfields InitListExprBits
ParenListExprBitfields ParenListExprBits
GenericSelectionExprBitfields GenericSelectionExprBits
PseudoObjectExprBitfields PseudoObjectExprBits
SourceLocExprBitfields SourceLocExprBits
CXXOperatorCallExprBitfields CXXOperatorCallExprBits
CXXRewrittenBinaryOperatorBitfields CXXRewrittenBinaryOperatorBits
CXXBoolLiteralExprBitfields CXXBoolLiteralExprBits
CXXNullPtrLiteralExprBitfields CXXNullPtrLiteralExprBits
CXXThisExprBitfields CXXThisExprBits
CXXThrowExprBitfields CXXThrowExprBits
CXXDefaultArgExprBitfields CXXDefaultArgExprBits
CXXDefaultInitExprBitfields CXXDefaultInitExprBits
CXXScalarValueInitExprBitfields CXXScalarValueInitExprBits
CXXNewExprBitfields CXXNewExprBits
CXXDeleteExprBitfields CXXDeleteExprBits
TypeTraitExprBitfields TypeTraitExprBits
DependentScopeDeclRefExprBitfields DependentScopeDeclRefExprBits
CXXConstructExprBitfields CXXConstructExprBits
ExprWithCleanupsBitfields ExprWithCleanupsBits
CXXUnresolvedConstructExprBitfields CXXUnresolvedConstructExprBits
CXXDependentScopeMemberExprBitfields CXXDependentScopeMemberExprBits
OverloadExprBitfields OverloadExprBits
UnresolvedLookupExprBitfields UnresolvedLookupExprBits
UnresolvedMemberExprBitfields UnresolvedMemberExprBits
CXXNoexceptExprBitfields CXXNoexceptExprBits
SubstNonTypeTemplateParmExprBitfields SubstNonTypeTemplateParmExprBits
RequiresExprBitfields RequiresExprBits
CoawaitExprBitfields CoawaitBits
ObjCIndirectCopyRestoreExprBitfields ObjCIndirectCopyRestoreExprBits
OpaqueValueExprBitfields OpaqueValueExprBits
}; |

## Detailed Description

CXXCatchStmt - This represents a C++ catch block.

Definition at line 28 of file StmtCXX.h.

## Constructor & Destructor Documentation

## ◆ CXXCatchStmt() [1/2]

clang::CXXCatchStmt::CXXCatchStmt | ( | SourceLocation | catchLoc,
|  | VarDecl * | exDecl,
|  | Stmt * | handlerBlock
| ) |  |
| inline

Definition at line 36 of file StmtCXX.h.

## ◆ CXXCatchStmt() [2/2]

clang::CXXCatchStmt::CXXCatchStmt | ( | EmptyShell | Empty | ) |
| inline

Definition at line 40 of file StmtCXX.h.

## Member Function Documentation

## ◆ children() [1/2]

child_range clang::CXXCatchStmt::children | ( |  | ) |
| inline

Definition at line 57 of file StmtCXX.h.

## ◆ children() [2/2]

const_child_range clang::CXXCatchStmt::children | ( |  | ) | const
| inline

Definition at line 59 of file StmtCXX.h.

## ◆ classof()

static bool clang::CXXCatchStmt::classof | ( | const Stmt * | T | ) |
| inline static

Definition at line 53 of file StmtCXX.h.

References clang::Stmt::getStmtClass().

## ◆ getBeginLoc()

SourceLocation clang::CXXCatchStmt::getBeginLoc | ( |  | ) | const
| inline

Definition at line 43 of file StmtCXX.h.

Referenced by clang::Sema::ActOnCXXTryBlock(), and clang::CoreturnStmt::getEndLoc().

## ◆ getCatchLoc()

SourceLocation clang::CXXCatchStmt::getCatchLoc | ( |  | ) | const
| inline

Definition at line 48 of file StmtCXX.h.

## ◆ getCaughtType()

QualType CXXCatchStmt::getCaughtType | ( |  | ) | const

Definition at line 19 of file StmtCXX.cpp.

References clang::ValueDecl::getType().

Referenced by getExceptionDecl().

## ◆ getEndLoc()

SourceLocation clang::CXXCatchStmt::getEndLoc | ( |  | ) | const
| inline

Definition at line 44 of file StmtCXX.h.

References clang::Stmt::getEndLoc().

## ◆ getExceptionDecl()

VarDecl* clang::CXXCatchStmt::getExceptionDecl | ( |  | ) | const
| inline

Definition at line 49 of file StmtCXX.h.

References getCaughtType().

Referenced by clang::Sema::ActOnCXXTryBlock(), print_block(), clang::ento::ExprEngine::VisitCXXCatchStmt(), and clang::ASTNodeTraverser< ASTDumper, TextNodeDumper >::VisitCXXCatchStmt().

## ◆ getHandlerBlock()

Stmt* clang::CXXCatchStmt::getHandlerBlock | ( |  | ) | const
| inline

Definition at line 51 of file StmtCXX.h.

## Friends And Related Function Documentation

## ◆ ASTStmtReader

friend class ASTStmtReader
| friend

Definition at line 63 of file StmtCXX.h.

The documentation for this class was generated from the following files:

- include/clang/AST/StmtCXX.h
- lib/AST/StmtCXX.cpp